function beginContact(a,b,coll)
    if a ~= nil and b ~= nil then
        if a:getUserData() == "ball" and b:getUserData() == "block" then
            b:setMask(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)
            table.insert(toRemove,b)
        elseif a:getUserData() == "block" and b:getUserData() == "ball" then
            b:setMask(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)
            table.insert(toRemove,a)
        end
    end
end

function love.load()
    love.physics.setMeter(64)
    world = love.physics.newWorld(0, 9.81*64, true)
    world:setCallbacks(beginContact, endContact, preSolve, postSolve)

    toRemove = {}

    ball = {}
    ball.body = love.physics.newBody(world, 200, 200, "dynamic")
    ball.shape = love.physics.newCircleShape(10)
    ball.fixture = love.physics.newFixture(ball.body, ball.shape, 1)
    local ball_name = "ball"
    ball.fixture:setUserData(ball_name)

    block = {}
    block.body = love.physics.newBody(world, 200, 500)
    block.shape = love.physics.newRectangleShape(200, 30)
    block.fixture = love.physics.newFixture(block.body, block.shape, 1)
    block.fixture:setSensor(true)
    local block_name = "block"
    block.fixture:setUserData(block_name)
end

function love.update(dt)
    world:update(dt)

    for _, fixture in ipairs(toRemove) do
        fixture:destroy()
    end
end

function love.draw()
    love.graphics.setColor(255,0,0)
    love.graphics.circle("line", ball.body:getX(), ball.body:getY(), ball.shape:getRadius())
    love.graphics.setColor(0,255,0)
    love.graphics.polygon("line", block.body:getWorldPoints(block.shape:getPoints()))
end

